unit mAnwendung;

Interface

uses
  mSum, mTSpielfeld, mTFarbKugel, mTKugel;

type
TAnwendung = CLASS
private
  derBildschirm : Bildschirm;
  dieMaus       : Maus;
  ersteKugel    : TKugel;
  zweiteKugel   : TFarbKugel;
  dasSpielfeld  : TSpielfeld;

public

  constructor init;
  Procedure laufe;
  destructor gibFrei;

end;

Implementation

constructor TAnwendung.init;
begin
  // Initialisierung
  randomize;
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  ersteKugel    := TKugel.init(50,50,0.05,random(360));
  zweiteKugel   := TFarbKugel.init(250,75,0.03,random(360));
  dasSpielfeld  := TSpielfeld.init(10,10,760,510);
end;

procedure TAnwendung.laufe;
begin
  // Aktionsteil
  ersteKugel.merkeSpielfeld(DasSpielfeld);
  zweiteKugel.merkeSpielfeld(DasSpielfeld);
  dasSpielfeld.zeichneDich;
  repeat
    ersteKugel.bewege;
    zweiteKugel.bewege;
  until dieMaus.istGedrueckt;
end;

destructor TAnwendung.gibFrei;
  // Aufrumen
begin
  ersteKugel.gibFrei;
  zweiteKugel.gibFrei;
  dieMaus.gibFrei;
  dasSpielfeld.gibFrei;
  derBildschirm.gibFrei
end;
end.
