UNIT mTKugel;

interface

uses            mSuM, mTSpielfeld;
// Uses-Klausel ggf. anpassen

type
   TKugel = CLASS

     // Attribute
     private
        hatStift : Stift;
        kenntSpielfeld : TSpielfeld;
     public
        Geschw : Zahl;
        Richtung : Zahl;

     //Objektbeziehungen:
        // hatStift : Stift;
        // kenntTSpielfeld : TSpielfeld;

     // Methoden
     private
        procedure Loesche;
        procedure setzeRichtung(pWinkel:Zahl);
        procedure Zeichne;
        function hPosition : Zahl;
        function vPosition : Zahl;
     public
        constructor init(px,py,v,alpha:Zahl);
        procedure Bewege;
        procedure merkeSpielfeld(PSpielfeld : TSpielfeld);
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKugel: Methodendefinition 
//+---------------------------------------------------------------------

//-------- Loesche (private) -------------------------------------------
procedure TKugel.Loesche;
begin
  hatStift.radiere;
  self.Zeichne;
  hatStift.normal
end;

//-------- setzeRichtung (private) -------------------------------------
procedure TKugel.setzeRichtung(pWinkel:Zahl);
begin
  hatStift.dreheBis(pWinkel)
end;

//-------- Zeichne (private) -------------------------------------------
procedure TKugel.Zeichne;
begin
  hatStift.zeichneKreis(10);
end;

//-------- hPosition (private) -----------------------------------------
function TKugel.hPosition : Zahl;
begin
  result:=hatStift.hPosition
end;

//-------- vPosition (private) -----------------------------------------
function TKugel.vPosition : Zahl;
begin
  result:=hatStift.vPosition
end;

//-------- init (public) -----------------------------------------------
constructor TKugel.init(px,py,v,alpha:Zahl);
begin
  hatStift := Stift.init;        // Stift erzeugen
  hatStift.dreheBis(alpha);
  Richtung := alpha;
  hatStift.bewegeBis(px,py);
  self.geschw := v;
  self.zeichne;
  
end;

//-------- Bewege (public) ---------------------------------------------
procedure TKugel.Bewege;
begin
  self.loesche;
  hatStift.bewegeUm(Geschw);       // an die Geschwindigkeit des Rechners anpassen!
  if self.hPosition > kenntSpielfeld.liesRechts-12 then // am rechten Rand angekommen (Radius der Kugel bercksichtigen!)
  begin
     Richtung := 180-Richtung;
     self.setzeRichtung(Richtung);  // nach links
  end;
  if self.hPosition < kenntSpielfeld.lieslinks+12 then // am linken Rand angekommen  (Radius der Kugel bercksichtigen!)
  begin
     Richtung := 180-Richtung;
     self.setzeRichtung(Richtung);    // nach rechts
  end;
  if self.vPosition > kenntSpielfeld.liesUnten-12 then // am unteren Rand angekommen (Radius der Kugel bercksichtigen!)
     begin
     Richtung := 360-Richtung;
     self.setzeRichtung(Richtung);  // nach oben
     end;
  if self.vPosition < kenntSpielfeld.liesOben+12 then // am oberen Rand angekommen  (Radius der Kugel bercksichtigen!)
  begin
     Richtung := 360-Richtung;
     self.setzeRichtung(Richtung);    // nach unten
  end;
  self.Zeichne;
end;

//-------- merkeSpielfeld (public) -------------------------------------
procedure TKugel.merkeSpielfeld(PSpielfeld : TSpielfeld);
begin
  kenntSpielfeld := PSpielfeld;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKugel.gibFrei;
begin
  hatStift.gibFrei;             // Stift wieder freigeben
end;

end.
