UNIT mTKugel;

interface

uses         mSuM, mTSpielfeld;
// Uses-Klausel ggf. anpassen

type
   TKugel = CLASS

     // Attribute
     private
        kenntSpielfeld : TSpielfeld;
     protected
         hatStift : Buntstift;
         zGeschwindigkeit : Zahl;
         zRadius : Zahl;

     // Methoden
     public
        constructor init(px,py,pr,pGeschwindigkeit:Zahl); virtual;
        procedure Bewege; virtual;
        procedure kennt(pSpielfeld:TSpielfeld);
        procedure Loesche;
        procedure setzeRichtung(pWinkel:Zahl);
        procedure Zeichne; virtual;
        function hPosition : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKugel: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TKugel.init(px,py,pr,pGeschwindigkeit:Zahl);
begin
  zGeschwindigkeit := pGeschwindigkeit;
  hatStift := BuntStift.init;       // Stift erzeugen
  hatStift.bewegeBis(px,py);
  zRadius:=pr;
end;

//-------- Bewege (public) ---------------------------------------------
procedure TKugel.Bewege;
begin
  self.loesche;
  hatStift.bewegeUm(zGeschwindigkeit);       // an die Geschwindigkeit des Rechners anpassen!
  if self.hPosition > kenntSpielfeld.liesRechts-ZRadius-1 then // am rechten Rand angekommen (Radius der Kugel bercksichtigen!)
     self.setzeRichtung(180);  // nach links
  if self.hPosition <  kenntSpielfeld.liesLinks+ZRadius+1 then // am linken Rand angekommen  (Radius der Kugel bercksichtigen!)
     self.setzeRichtung(0);    // nach rechts
  self.Zeichne;
end;

//-------- kennt (public) ----------------------------------------------
procedure TKugel.kennt(pSpielfeld:TSpielfeld);
begin
   kenntSpielfeld := pSpielfeld
end;

//-------- Loesche (public) --------------------------------------------
procedure TKugel.Loesche;
begin
  hatStift.radiere;
  self.Zeichne;
  hatStift.normal
end;

//-------- setzeRichtung (public) --------------------------------------
procedure TKugel.setzeRichtung(pWinkel:Zahl);
begin
  hatStift.dreheBis(pWinkel)
end;

//-------- Zeichne (public) --------------------------------------------
procedure TKugel.Zeichne;
begin
  hatStift.zeichneKreis(ZRadius);
end;

//-------- hPosition (public) ------------------------------------------
function TKugel.hPosition : Zahl;
begin
  result:=hatStift.hPosition
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKugel.gibFrei;
begin
  hatStift.gibFrei;             // Stift wieder freigeben
end;

end.
