UNIT mTKugel;

interface

uses      mSuM, mTSpielfeld;
// Uses-Klausel ggf. anpassen

type
   TKugel = CLASS

     // Attribute
     private
        kenntFeld : TSpielfeld;
        zHMax : Zahl;
        zHMin : Zahl;
        zVMin : zahl;
        zVMax : zahl;
        zveloc :Zahl;
        zfarbe : Integer;
       // hatStift : BuntStift;

     protected
        radius   : Integer;
        imSpiel  : Boolean;
        hatStift : BuntStift;

     private

        procedure setzeRichtung(pWinkel:Zahl);


     protected
     procedure zeichne;

     public
        constructor init(px:zahl; py:zahl; pRichtung:Zahl; pvelocity:Zahl; pfarbe: Integer; pSpielfeld: TSpielfeld);   virtual;
        procedure bewege;   virtual;
        procedure loesche;
        function hPosition : Zahl;
        function vposition : Zahl;
        function aktiv : Boolean;
        destructor gibFrei;
        procedure schalteDichAb;
    end;

implementation

//+---------------------------------------------------------------------
//|         TKugel: Methodendefinition
//+---------------------------------------------------------------------

//-------- loesche (private) -------------------------------------------
procedure TKugel.loesche;
begin
  hatStift.radiere;
  self.Zeichne;
  hatStift.normal
end;

//-------- setzeRichtung (private) -------------------------------------
procedure TKugel.setzeRichtung(pWinkel:Zahl);
begin
  hatStift.dreheBis(pWinkel)
end;

//-------- schalteDichAb (protected) -------------------------------------
procedure TKugel.schalteDichAb;
begin
  imSpiel := False;
  self.loesche;
end;

//-------- zeichne (private) -------------------------------------------
procedure TKugel.zeichne;
begin
  hatStift.setzeFarbe(zfarbe);
  hatStift.setzeLinienbreite(radius);
  hatStift.zeichneKreis(radius div 2-1);
end;

//-------- hPosition (private) -----------------------------------------
function TKugel.hPosition : Zahl;
begin
  result:=hatStift.hPosition
end;

//-------- hPosition (private) -----------------------------------------
function TKugel.vPosition : Zahl;
begin
  result:=hatStift.vPosition
end;

//-------- aktiv (public) -----------------------------------------
function TKugel.aktiv : Boolean;
begin
  result:=imSpiel;
end;

//-------- init (public) -----------------------------------------------
constructor TKugel.init(px:zahl; py:zahl ; prichtung:zahl; pvelocity:zahl; pfarbe:INTEGER;
            pSpielfeld: TSpielfeld);
begin
  radius := 10;
  imSpiel := True;
  hatStift := BuntStift.init;
  self.kenntFeld := pSpielfeld;
  zHMax := kenntFeld.liesrechts;
  zHMin := kenntFeld.lieslinks;
  zVMin := kenntFeld.liesoben;
  zVMax := kenntFeld.liesunten;
  zveloc:= pvelocity;
  zfarbe:= pfarbe;
    // Stift erzeugen
  hatStift.bewegeBis(px,py);       // Benutzt den Stift als Speicher des Zustands.
  self.setzeRichtung(prichtung);
  self.zeichne
end;

//-------- bewege (public) ---------------------------------------------
procedure TKugel.bewege;
begin
  self.loesche;
  hatStift.bewegeUm(0.05*zveloc);       // an die Geschwindigkeit des Rechners anpassen!
  IF self.vposition < zVMin+radius+3 then hatStift.dreheUm(-2*hatStift.winkel) ;
  IF self.vposition > zVMax-radius-3 then hatStift.dreheUm(-2*hatStift.winkel) ;
  IF self.hposition > zHMax-radius-3 then hatStift.dreheUm(900-2*hatStift.winkel) ;
  IF self.hposition < zHMin+radius+3 then hatStift.dreheUm(900-2*hatStift.winkel) ;
  self.Zeichne;
end;


//-------- gibFrei (public) --------------------------------------------
destructor TKugel.gibFrei;
begin
  hatStift.gibFrei;             // Stift wieder freigeben
end;

end.
