UNIT mTKugel;

interface

uses              mSuM, mTSpielfeld;
// Uses-Klausel ggf. anpassen

type
   TKugel = CLASS

     // Attribute
     private
        kenntSpielfeld : TSpielfeld;
     protected
         hatStift : Buntstift;

     //Objektbeziehungen:
        // hatBuntstift : Buntstift;
        // kenntTSpielfeld : TSpielfeld;

     // Methoden
     private
        procedure Loesche;
        procedure setzeRichtung(pWinkel:Zahl);
        function hPosition : Zahl;
        function vPosition : Zahl;
     protected
        procedure Zeichne; virtual;
     public
        constructor init(px,py:Zahl);
        procedure Bewege;
        procedure merkeSpielfeld(pSpielfeld : TSpielfeld);
        procedure setzeStartrichtung(pWinkel : Zahl);
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKugel: Methodendefinition 
//+---------------------------------------------------------------------

//-------- Loesche (private) -------------------------------------------
procedure TKugel.Loesche;
begin
  hatStift.radiere;
  self.Zeichne;
  hatStift.normal
end;

//-------- setzeRichtung (private) -------------------------------------
procedure TKugel.setzeRichtung(pWinkel:Zahl);
begin
  hatStift.dreheBis(pWinkel)
end;

//-------- hPosition (private) -----------------------------------------
function TKugel.hPosition : Zahl;
begin
  result:=hatStift.hPosition
end;

//-------- vPosition (private) -----------------------------------------
function TKugel.vPosition : Zahl;
begin
    result:=hatStift.vPosition
end;

//-------- Zeichne (protected) -----------------------------------------
procedure TKugel.Zeichne;
begin
  hatStift.zeichneKreis(10);
end;

//-------- init (public) -----------------------------------------------
constructor TKugel.init(px,py:Zahl);
begin
  hatStift := BuntStift.init;       // Stift erzeugen
  hatStift.bewegeBis(px,py);
  self.zeichne 
end;

//-------- Bewege (public) ---------------------------------------------
procedure TKugel.Bewege;
begin
  self.loesche;
  hatStift.bewegeUm(0.01);       // an die Geschwindigkeit des Rechners anpassen!
  if self.vPosition > kenntSpielfeld.liesUnten -12 then // Unten angekommen (Radius der Kugel bercksichtigen!)
     self.setzeRichtung(-hatStift.winkel) ;
  if self.vPosition < kenntSpielfeld.liesOben   +12 then // Oben angekommen  (Radius der Kugel bercksichtigen!)
     self.setzeRichtung(-hatStift.winkel)  ;
  if self.hPosition > kenntSpielfeld.liesRechts -12 then // am rechten Rand angekommen (Radius der Kugel bercksichtigen!)
     IF  hatStift.winkel < - 90
         Then self.setzeRichtung(-hatStift.winkel - 180)
         ELSE self.setzeRichtung(-hatStift.winkel + 180);
  if self.hPosition < kenntSpielfeld.liesLinks   +12 then // am linken Rand angekommen  (Radius der Kugel bercksichtigen!)
     IF hatStift.winkel > 180
        THEN self.setzeRichtung(-hatStift.winkel - 180)
        ELSE self.setzeRichtung(-hatStift.winkel + 180);
  self.Zeichne;
end;

//-------- merkeSpielfeld (public) -------------------------------------
procedure TKugel.merkeSpielfeld(pSpielfeld : TSpielfeld);
begin
   kenntSpielfeld := pSpielfeld;
end;

//-------- setzeStartrichtung (public) ---------------------------------
procedure TKugel.setzeStartrichtung(pWinkel : Zahl);
begin
     hatStift.dreheBis(pWinkel)
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKugel.gibFrei;
begin
  hatStift.gibFrei;             // Stift wieder freigeben
end;

end.
