UNIT mTKugel;

interface

uses         mSuM,mTSpielfeld;
// Uses-Klausel ggf. anpassen

type
   TKugel = CLASS 

     // Attribute
     private
        hatStift : Stift;
        kenntSpielfeld : TSpielfeld;
        zRichtung : zahl;
     protected
         zGeschwindigkeit : zahl;

     //Objektbeziehungen:
        // hatStift : Stift;
        // kenntTSpielfeld : TSpielfeld;

     // Methoden
     private
        procedure Loesche;
        procedure setzeRichtung(pWinkel:Zahl);
        procedure Zeichne;
        function hPosition : Zahl;
        function vPosition : Zahl;
     public
        constructor init(px,py, pwinkel, pgeschwindigkeit:Zahl);
        procedure Bewege; virtual;
        procedure lerneSpielfeldKennen(pSpielfeld: TSpielfeld);
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKugel: Methodendefinition
//+---------------------------------------------------------------------

//-------- Loesche (private) -------------------------------------------
procedure TKugel.Loesche;
begin
  hatStift.radiere;
  self.Zeichne;
  hatStift.normal
end;

//-------- setzeRichtung (private) -------------------------------------
procedure TKugel.setzeRichtung(pWinkel:Zahl);
begin
  hatStift.dreheBis(pWinkel);
  zrichtung := pWinkel;
end;

//-------- Zeichne (private) -------------------------------------------
procedure TKugel.Zeichne;
begin
  hatStift.zeichneKreis(10);
end;

//-------- hPosition (private) -----------------------------------------
function TKugel.hPosition : Zahl;
begin
  result:=hatStift.hPosition
end;

function TKugel.vPosition : Zahl;
begin
  result:=hatStift.vPosition
end;

//-------- init (public) -----------------------------------------------
constructor TKugel.init(px,py, pwinkel, pgeschwindigkeit :Zahl);
begin
  zGeschwindigkeit := pGeschwindigkeit;
  hatStift := Stift.init;       // Stift erzeugen
  hatStift.bewegeBis(px,py);
  hatStift.dreheBis (pwinkel);
  zrichtung := pwinkel;
  self.zeichne
end;

//-------- Bewege (public) ---------------------------------------------
procedure TKugel.Bewege;
begin
  self.loesche;
  hatStift.bewegeUm(zGeschwindigkeit);       // an die Geschwindigkeit des Rechners anpassen!
  if self.hPosition > kenntSpielfeld.liesrechts-12 then // am rechten Rand angekommen (Radius der Kugel bercksichtigen!)
     self.setzeRichtung(180 - zrichtung);  // nach links
  if self.hPosition < kenntSpielfeld.lieslinks +12 then // am linken Rand angekommen  (Radius der Kugel bercksichtigen!)
     self.setzeRichtung(180 - zrichtung);    // nach rechts
  if self.vPosition > kenntSpielfeld.liesunten-12 then // am rechten Rand angekommen (Radius der Kugel bercksichtigen!)
     self.setzeRichtung(- zrichtung);  // nach links
  if self.vPosition < kenntSpielfeld.liesoben +12 then // am linken Rand angekommen  (Radius der Kugel bercksichtigen!)
     self.setzeRichtung(- zrichtung);    // nach rechts
  self.Zeichne;
end;

//-------- lerneSpielfeldKennen (public) -------------------------------
procedure TKugel.lerneSpielfeldKennen(pSpielfeld: TSpielfeld);
begin
  kenntSpielfeld := pSpielfeld;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKugel.gibFrei;
begin
  hatStift.gibFrei;             // Stift wieder freigeben
end;

end.
