UNIT mTRandkugel;

interface

uses        mSuM, mTKugel;
// Uses-Klausel ggf. anpassen

type
   TRandkugel = CLASS(TKugel)

     // Attribute
     private
        hatBuntStift : BuntStift;
        zRanddicke : GanzeZahl;

     // Methoden
     public
        constructor init(pX, pY,pGeschwindigkeit :Zahl); override;
        procedure bewege; override;
        procedure loesche; override;
        procedure setzeRichtung(pWinkel:Zahl); override;
        procedure zeichne; override;
        function hPosition : Zahl; override;
        destructor gibFrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TRandkugel: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TRandkugel.init(pX, pY,pGeschwindigkeit :Zahl);
begin
   zRanddicke := 3;
   hatBuntStift := BuntStift.init;       // Stift erzeugen
   hatBuntStift.bewegeBis(px,py);
   zGeschwindigkeit := pGeschwindigkeit;
end;   

//-------- bewege (public) ---------------------------------------------
procedure TRandkugel.bewege;
begin
  self.loesche;
  hatBuntStift.bewegeUm(zGeschwindigkeit);       // an die Geschwindigkeit des Rechners anpassen!
  if self.hPosition > kenntSpielfeld.liesRechts-12 then // am rechten Rand angekommen (Radius der Kugel bercksichtigen!)
     self.setzeRichtung(180);  // nach links
  if self.hPosition <  kenntSpielfeld.liesLinks+12 then // am linken Rand angekommen  (Radius der Kugel bercksichtigen!)
     self.setzeRichtung(0);    // nach rechts
  self.Zeichne;
end;

//-------- loesche (public) --------------------------------------------
procedure TRandkugel.loesche;
begin
  hatBuntStift.radiere;
  self.Zeichne;
  hatBuntStift.normal
end;

//-------- setzeRichtung (public) --------------------------------------
procedure TRandkugel.setzeRichtung(pWinkel:Zahl);
begin
  hatBuntStift.dreheBis(pWinkel)
end;

//-------- zeichne (public) --------------------------------------------
procedure TRandkugel.zeichne;
begin
   hatBuntStift.setzeLinienBreite(zRanddicke);
   hatBuntStift.zeichneKreis(10)
end;

//-------- hPosition (public) ------------------------------------------
function TRandkugel.hPosition : Zahl;
begin
  result:=hatBuntStift.hPosition
end;

//-------- gibFrei (public) --------------------------------------------
destructor TRandkugel.gibFrei;
begin
   hatBuntStift.GibFrei
end;

end.
