UNIT mTKugel;

interface

uses              mSuM,mTSpielfeld,mTSchlaeger;
// Uses-Klausel ggf. anpassen

type
   TKugel = CLASS

     // Attribute
     private
        hatStift : Stift;
        kenntSchlaeger : TSchlaeger;
        kenntSpielfeld : TSpielfeld;
        zGeschwindigkeit : Zahl;

     // Methoden
     private
        procedure loesche;
        procedure refelektiereAnSchlaeger;
        procedure setzeRichtung(pWinkel:Zahl);
        procedure zeichne;
        function beruehrtLinks : Wahrheitswert;
        function beruehrtLinksOben : Wahrheitswert;
        function beruehrtLinksUnten : Wahrheitswert;
        function beruehrtOben : Wahrheitswert;
        function beruehrtRechts : Wahrheitswert;
        function beruehrtRechtsOben : Wahrheitswert;
        function beruehrtRechtsUnten : Wahrheitswert;
        function beruehrtSchlaeger : Wahrheitswert;
        function beruehrtUnten : Wahrheitswert;
     public
        constructor init(px,py,pRichtung,pGeschwindigkeit:Zahl);
        procedure bewege;
        procedure merkeSchlaeger(pSchlaeger:TSchlaeger);
        procedure merkeSpielfeld(pSpielfeld:TSpielfeld);
        function links : Zahl;
        function oben : Zahl;
        function rechts : Zahl;
        function unten : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKugel: Methodendefinition 
//+---------------------------------------------------------------------

//-------- loesche (private) -------------------------------------------
procedure TKugel.loesche;
begin
  hatStift.radiere;
  self.Zeichne;
  hatStift.normal
end;

//-------- refelektiereAnSchlaeger (private) ---------------------------
procedure TKugel.refelektiereAnSchlaeger;
begin
     while hatStift.winkel > 360 do
           hatStift.dreheBis(hatStift.winkel-360);
     while hatStift.winkel < 0 do
           hatStift.dreheBis(hatStift.winkel+360);

     if beruehrtOben then hatStift.dreheBis (-hatStift.winkel)
     else if beruehrtUnten then hatStift.dreheBis (-hatStift.winkel)
     else if beruehrtRechts then hatStift.dreheBis (180-hatStift.winkel)
     else if beruehrtLinks then begin hatStift.dreheBis (180-hatStift.winkel);bewege end
     else if beruehrtLinksOben then hatStift.dreheBis (180+hatStift.winkel)
     else if beruehrtRechtsUnten then hatStift.dreheBis (180+hatStift.winkel)
     else if beruehrtRechtsOben then hatStift.dreheBis (180+hatStift.winkel)
     else if beruehrtLinksUnten then hatStift.dreheBis (180+hatStift.winkel);
end;

//-------- setzeRichtung (private) -------------------------------------
procedure TKugel.setzeRichtung(pWinkel:Zahl);
begin
  hatStift.dreheBis(pWinkel)
end;

//-------- zeichne (private) -------------------------------------------
procedure TKugel.zeichne;
begin
  hatStift.zeichneKreis(10);
end;

//-------- beruehrtLinks (private) -------------------------------------
function TKugel.beruehrtLinks : Wahrheitswert;
begin
  result := (rechts > kenntSchlaeger.liesLinks) and
            (rechts < kenntSchlaeger.liesLinks+2*zGeschwindigkeit) and
            (hatStift.vPosition  > kenntSchlaeger.liesOben) and
            (hatStift.vPosition    < kenntSchlaeger.liesUnten)
end;

//-------- beruehrtLinksOben (private) ---------------------------------
function TKugel.beruehrtLinksOben : Wahrheitswert;
begin
   result := (sqrt(sqr(hatStift.hPosition - kenntSchlaeger.LiesLinks)+
                  sqr(hatStift.vPosition - kenntSchlaeger.LiesOben)) < 10)
end;

//-------- beruehrtLinksUnten (private) --------------------------------
function TKugel.beruehrtLinksUnten : Wahrheitswert;
begin
   result := (sqrt(sqr(hatStift.hPosition - kenntSchlaeger.LiesLinks)+
                  sqr(hatStift.vPosition - kenntSchlaeger.LiesUnten)) < 10)
end;

//-------- beruehrtOben (private) --------------------------------------
function TKugel.beruehrtOben : Wahrheitswert;
begin
  result := (unten > kenntSchlaeger.liesOben) and
            (unten < kenntSchlaeger.liesOben+2*zGeschwindigkeit) and
            (hatStift.hPosition > kenntSchlaeger.liesLinks) and
            (hatStift.hPosition  < kenntSchlaeger.liesRechts)
end;

//-------- beruehrtRechts (private) ------------------------------------
function TKugel.beruehrtRechts : Wahrheitswert;
begin
  result := (links < kenntSchlaeger.liesRechts) and
            (links > kenntSchlaeger.liesRechts-2*zGeschwindigkeit ) and
            (hatStift.vPosition  > kenntSchlaeger.liesOben) and
            (hatStift.vPosition    < kenntSchlaeger.liesUnten)
end;

//-------- beruehrtRechtsOben (private) --------------------------------
function TKugel.beruehrtRechtsOben : Wahrheitswert;
begin
   result := (sqrt(sqr(hatStift.hPosition - kenntSchlaeger.LiesRechts)+
                  sqr(hatStift.vPosition - kenntSchlaeger.LiesOben)) < 10)
end;

//-------- beruehrtRechtsUnten (private) -------------------------------
function TKugel.beruehrtRechtsUnten : Wahrheitswert;
begin
   result := (sqrt(sqr(hatStift.hPosition - kenntSchlaeger.LiesRechts)+
                  sqr(hatStift.vPosition - kenntSchlaeger.LiesUnten)) < 10)
end;

//-------- beruehrtSchlaeger (private) ---------------------------------
function TKugel.beruehrtSchlaeger : Wahrheitswert;
begin
   result := beruehrtOben or
             beruehrtUnten or
             beruehrtlinks or
             beruehrtRechts or
             beruehrtLinksOben or
             beruehrtRechtsOben or
             beruehrtLinksUnten or
             beruehrtRechtsUnten
end;

//-------- beruehrtUnten (private) -------------------------------------
function TKugel.beruehrtUnten : Wahrheitswert;
begin
  result := (oben < kenntSchlaeger.liesUnten) and
            (oben > kenntSchlaeger.liesUnten-2*zGeschwindigkeit ) and
            (hatStift.hPosition > kenntSchlaeger.liesLinks) and
            (hatStift.hPosition  < kenntSchlaeger.liesRechts)
end;

//-------- init (public) -----------------------------------------------
constructor TKugel.init(px,py,pRichtung,pGeschwindigkeit:Zahl);
begin
  hatStift := Stift.init;       // Stift erzeugen
  hatStift.bewegeBis(px,py);
  hatStift.dreheBis(pRichtung);
  zGeschwindigkeit := pGeschwindigkeit;
  self.zeichne
end;

//-------- bewege (public) ---------------------------------------------
procedure TKugel.bewege;
   var vx,vy :Zahl;
begin
  self.loesche;
  hatStift.bewegeUm(zGeschwindigkeit);       
  if hatStift.hPosition > kenntSpielfeld.liesRechts -12 then
     hatStift.dreheBis (180-hatStift.winkel);
  if hatStift.hPosition < kenntSpielfeld.liesLinks + 12 then
     hatStift.dreheBis (180-hatStift.winkel);
  if hatStift.vPosition < kenntSpielfeld.liesOben + 12 then
     hatStift.dreheBis (-hatStift.winkel);
  if hatStift.vPosition > kenntSpielfeld.liesUnten - 12 then
     hatStift.dreheBis (-hatStift.winkel);
  self.refelektiereAnSchlaeger;   
  self.Zeichne;
end;

//-------- merkeSchlaeger (public) -------------------------------------
procedure TKugel.merkeSchlaeger(pSchlaeger:TSchlaeger);
begin
  kenntSchlaeger := pSchlaeger
end;

//-------- merkeSpielfeld (public) -------------------------------------
procedure TKugel.merkeSpielfeld(pSpielfeld:TSpielfeld);
begin
   kenntSpielfeld := pSpielfeld  ///test
end;

//-------- links (public) ----------------------------------------------
function TKugel.links : Zahl;
begin
   result := hatStift.hPosition-10
end;

//-------- oben (public) -----------------------------------------------
function TKugel.oben : Zahl;
begin
   result := hatStift.vPosition-10
end;

//-------- rechts (public) ---------------------------------------------
function TKugel.rechts : Zahl;
begin
   result := hatStift.hPosition+10
end;

//-------- unten (public) ----------------------------------------------
function TKugel.unten : Zahl;
begin
   result := hatStift.vPosition+10
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKugel.gibFrei;
begin
  hatStift.gibFrei;             // Stift wieder freigeben
end;

end.
