program tennis;

uses
  mSum,
  mTSpielfeld in 'mTSpielfeld.pas',
  mTKugel in 'mTKugel.pas',
  mTSchlaeger in 'mTSchlaeger.pas',
  mTBox in 'mTBox.pas';

var
  derBildschirm : Bildschirm;
  dieMaus       : Maus;
  dieTastatur   : Tastatur;
  hatStift      : Stift;
  ersteKugel    : TKugel;
  zweiteKugel   : TKugel;
  dasSpielfeld  : TSpielfeld;
  derSchlaeger  : TSchlaeger;
  dieBox        : TBox;

begin
  // Initialisierung
  randomize;
  derBildschirm := Bildschirm.init;
  dieTastatur   := Tastatur.init;
  dieMaus       := Maus.init;
  hatStift      := Stift.init;
  dasSpielfeld  := TSpielfeld.init(10,10,700,210);
  derSchlaeger  := TSchlaeger.init(20,100,30,150,rot);
  dieBox        := TBox.init(500,100,530,130,gruen);
  ersteKugel    := TKugel.init(50+random(5),50,10+random(5),0.2);
  ersteKugel.merkeSpielfeld(dasSpielfeld);
  ersteKugel.merkeSchlaeger(derSchlaeger);
  ersteKugel.merkeBox(dieBox);
  zweiteKugel    := TKugel.init(450,150+random(5),155+random(5),0.23);
  zweiteKugel.merkeSpielfeld(dasSpielfeld);
  zweiteKugel.merkeSchlaeger(derSchlaeger);
  zweiteKugel.merkeBox(dieBox);

  // Aktionsteil
  dasSpielfeld.zeichneDich;
  derSchlaeger.zeichneDich;
  dieBox.zeichneDich;
  repeat
    ersteKugel.bewege;
    zweiteKugel.bewege;
    dieBox.zeichneDich;
    if dieTastatur.wurdeGedrueckt then
       begin
          derSchlaeger.reagiereAuf(dieTastatur.zeichen);
          dieTastatur.weiter
       end;
    //derSchlaeger.zeichneDich;
  until dieMaus.istGedrueckt
        or (ersteKugel.links < derSchlaeger.liesLinks)
        or (zweiteKugel.links < derSchlaeger.liesLinks)
        or (ersteKugel.inBox and zweiteKugel.inBox);
  hatStift.bewegeBis(50,100);
  if ersteKugel.links < derSchlaeger.liesLinks then
     hatStift.schreibeText('verloren')
  else if zweiteKugel.links < derSchlaeger.liesLinks then
     hatStift.schreibeText('verloren')
  else
     hatStift.schreibeText('gewonnen') ;
  

  // Aufrumen
  ersteKugel.gibFrei;
  dieMaus.gibFrei;
  dasSpielfeld.gibFrei;
  derSchlaeger.gibFrei;
  derBildschirm.gibFrei
end.
